/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_kernel.h 739 2010-11-24 04:14:37Z ertl-honda $
 */

/*
 *  kernel.hΥåװ¸AT91SKYEYEѡ
 *
 *  Υ󥯥롼ɥեϡkernel.hǥ󥯥롼ɤ롥¾Υե
 *  뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥󥯥롼
 *  ˡt_stddef.h󥯥롼ɤΤǡ˰¸Ƥ
 *  
 */

#ifndef TOPPERS_TARGET_KERNEL_H
#define TOPPERS_TARGET_KERNEL_H

/*
 *  ¸Ƕ̤ARMѡ
 */
#include "arm_gcc/common/core_kernel.h"

/*
 *  ƥδ
 */
#if !defined(TOPPERS_SYSTIM_LOCAL) && !defined(TOPPERS_SYSTIM_GLOBAL)
#define TOPPERS_SYSTIM_LOCAL			/* 륿Υƥ */
//#define TOPPERS_SYSTIM_GLOBAL			/* Х륿Υƥ */
#endif /* defined(TOPPERS_SYSTIM_LOCAL) || defined(TOPPERS_SYSTIM_GLOBAL) */

/*
 *  åȰ¸ǥݡȤǤ뵡ǽ
 */
#define TOPPERS_TARGET_SUPPORT_DIS_INT		/* dis_int */
#define TOPPERS_TARGET_SUPPORT_ENA_INT		/* ena_int */
#ifdef TOPPERS_SYSTIM_LOCAL
#define TOPPERS_TARGET_SUPPORT_GET_UTM		/* get_utm */
#endif /* TOPPERS_SYSTIM_LOCAL */

/*
 *  Х륿ΥƥץåID
 */
#ifndef TOPPERS_SYSTIM_PRCID
#define TOPPERS_SYSTIM_PRCID  1
#endif /* TOPPERS_SYSTIM_PRCID */

/*
 *  ޥץåID
 */
#ifndef TOPPERS_MASTER_PRCID
#define TOPPERS_MASTER_PRCID  1
#endif  /* TOPPERS_MASTER_PRCID */

/*
 * ץå
 */
#ifndef TNUM_PRCID
#define TNUM_PRCID  2
#endif /* TNUM_PRCID */

/*
 *  ͥ٤ϰ
 */
#define TMIN_INTPRI   (-7)        /* ͥ٤κǾ͡ʺǹ͡*/
#define TMAX_INTPRI   (-1)        /* ͥ٤κ͡ʺ͡*/

/*
 *  ƥå
 */
#define TIC_NUME     1U            /* ƥåμʬ */
#define TIC_DENO     1U            /* ƥåμʬ */

/*
 *  °
 */
#define	TA_POSEDGE		0x02U		/* ݥƥ֥åȥꥬ */
#define	TA_LOWLEVEL		0x00U		/* ٥ȥꥬ */
#define	TA_HIGHLEVEL	0x08U		/* ϥ٥ȥꥬ */

/*
 *  饹ID
 */
#define TCL_1   1
#define TCL_2   2
#define TCL_3   3
#define TCL_4   4
#define TCL_1_ONLY   5
#define TCL_2_ONLY   6 
#define TCL_3_ONLY   7
#define TCL_4_ONLY   8
#define TCL_SYSTIM_PRC   9

#endif /* TOPPERS_TARGET_KERNEL_H */
